
#ifndef PF_USER_CUSTOM

/***************************************************************
***************************************************************/


#include "../../../all.h"

static int32 CTest0( int32 Val );
static void CTest1( int32 Val1, cell Val2 );


/****************************************************************
** Step 1: Put your own special glue routines here
**     or link them in from another file or library.
****************************************************************/

static int32 CTest0( int32 Val )
{
	MSG_NUM_D("CTest0: Val = ", Val);
	return Val+1;
}

static void CTest1( int32 Val1, cell Val2 )
{
	MSG("CTest1: Val1 = "); ffDot(Val1);
	MSG_NUM_D(", Val2 = ", Val2);
}


#include "unistd.h"







/****************************************************************
** Step 2: Create CustomFunctionTable.
**     Do not change the name of CustomFunctionTable!
**     It is used by the pForth kernel.
****************************************************************/

void *CustomFunctionTable[] =
{
	CTest0,
	CTest1	

#include "names.h"


};	

/****************************************************************
** Step 3: Add custom functions to the dictionary.
**     Do not change the name of CompileCustomFunctions!
**     It is called by the pForth kernel.
****************************************************************/

#if (!defined(PF_NO_INIT)) && (!defined(PF_NO_SHELL))
int customIndex;
Err CompileCustomFunctions( void )
{
	Err err;

/* Compile Forth words that call your custom functions.
** Make sure order of functions matches that in LoadCustomFunctionTable().

*/
	err = CreateGlueToC( "CTEST0", 0, C_RETURNS_VALUE, 1 );
	if( err < 0 ) return err;
	err = CreateGlueToC( "CTEST1", 1, C_RETURNS_VOID, 2 );
	if( err < 0 ) return err;
	customIndex = 2 ;	/* postincrement customIndex in the #include */

#	include "glue.h"
	
	return 0;
}
#else
	Err CompileCustomFunctions( void ) { return 0; }
#endif

/****************************************************************
** Step 4: Recompile using compiler option PF_USER_CUSTOM
**         and link with your code.
**         Then rebuild the Forth using "pforth -i"
**         Test:   10 Ctest0 ( should print message then '11' )
****************************************************************/

#endif  /* PF_USER_CUSTOM */

